]> git.donarmstrong.com Git - zsh.git/blobdiff - .zsh/func/vcsh
Revert "abbreviations should be two chars!"
[zsh.git] / .zsh / func / vcsh
index 09597847227ee4ca06bea75b88aace5eddb7f805..7a860681c49951caf6149c26e6c479cef9270e93 100755 (executable)
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/zsh
 #
 # func/vcsh
 #
@@ -7,31 +7,39 @@
 # Copyright © 1994–2008 martin f. krafft <madduck@madduck.net>
 # Released under the terms of the Artistic Licence 2.0
 #
-# Source repository: http://git.madduck.net/v/etc/zsh.git
+# Source repository: git://git.madduck.net/etc/zsh.git
 #
 
-FGIT_BASE="$HOME/.fgits"
+local FGIT_BASE="$HOME/.fgits"
 
 if [ "${1:---help}" = '--help' ] || [ $# -gt 1 ]; then
-  echo "usage: ${0%/*} reponame" >&2
-  echo "usage: ${0%/*} -l" >&2
+  echo "usage: ${0##*/} reponame" >&2
+  echo "usage: ${0##*/} -l" >&2
   [ "$1" = '--help' ]
-  exit $?
+  return $?
 
 elif [ "$1" = '-l' ]; then
   for i in $FGIT_BASE/*.git; do
     i="${i#$FGIT_BASE/}"
     echo "${i%.git}"
   done
-  exit 0
+  return 0
 fi
 
 if [ ! -d "$FGIT_BASE/${1}.git" ]; then
   echo E: no repository found for "$1" >&2
-  exit 2
+  return 2
 fi
 
-export GIT_DIR=$FGIT_BASE/${1}.git
-git status
+old_GIT_DIR="${GIT_DIR:-}"
+old_GIT_WORK_TREE="${GIT_WORK_TREE:-}"
 
-PS1="{VCSH:$1}$PS1" $SHELL -i
+export GIT_DIR="$FGIT_BASE/${1}.git"
+export GIT_WORK_TREE="$GIT_DIR/$(git config --get core.worktree)"
+
+PS1="%S{${0##*/}:$1}%s$PS1" $SHELL -i || :
+
+GIT_DIR="$old_GIT_DIR"
+[ -z "$GIT_DIR" ] && unset GIT_DIR
+GIT_WORK_TREE="$old_GIT_WORK_TREE"
+[ -z "$GIT_WORK_TREE" ] && unset GIT_WORK_TREE